
#include    <stdio.h>
#include    <conio.h>
#include    "CiApi.h"
#include	"BFApi.h"
#include	"dsapi.h" 
#include	"BFErApi.h"

// prototype
UINT Thread(LPVOID lpdwParam);

// globals
CiENTRY entry;
Bd hBoard;
CiSIGNAL EODSignal;
PBFVOID pBitmap;
int hDspSrf;
BFBOOL Running;
DWORD dwThreadId;
HANDLE hThread;

int GetDeviceName( CiENTRY *pEntry, char *pchDeviceName )
{
	Bd		hBrd;
	int		iResult;

	CiBrdOpen(pEntry, &hBrd, BFSysNoCameraOpen);

#if 0
	{
		BFBOOL	bResult;

		bResult = BFIsNeon( hBrd );
		bResult = BFIsR2( hBrd );
		bResult = BFIsRv( hBrd );
		bResult = BFIsR64( hBrd );
		bResult = BFIsR64Board( hBrd );
		bResult = BFIsCL( hBrd );
		bResult = BFIsR3( hBrd );
		bResult = BFIsPMC( hBrd );
		bResult = BFIsPLDA( hBrd );
		bResult = BFIsKbn( hBrd );
		bResult = BFIsKbn4( hBrd );
		bResult = BFIsKbn2( hBrd );
		bResult = BFIsKbnBase( hBrd );
		bResult = BFIsKbnFull( hBrd );
		bResult = BFIsNeon( hBrd );
		bResult = BFIsNeonBase( hBrd );
		bResult = BFIsNeonD( hBrd );
		bResult = BFIsNeonQ( hBrd );
		bResult = BFIsAlta( hBrd );
		bResult = BFIsAltaAN( hBrd );
		bResult = BFIsAltaCO( hBrd );
		bResult = BFIsAltaYPC( hBrd );
		bResult = BFIsAlta1( hBrd );
		bResult = BFIsAlta2( hBrd );
		bResult = BFIsAlta4( hBrd );
		bResult = BFIsMaster( hBrd );
		bResult = BFIsSlave( hBrd );
		bResult = BFIsEncDiv( hBrd );
		bResult = BFIsNTG( hBrd );
		bResult = BFIsKbnCXP( hBrd );
		bResult = BFIsKbnCXP1( hBrd );
		bResult = BFIsKbnCXP2( hBrd );
		bResult = BFIsKbnCXP4( hBrd );
	}
#endif

	if( BFIsNeonBase( hBrd ) ){
		strcpy( pchDeviceName, "GingaDG-CL1e-B" );
		iResult = 0;
	}
	else if( BFIsNeonD( hBrd ) ){
		strcpy( pchDeviceName, "GingaDG-CL2e-DL" );
		iResult = 0;
	}
	else{
		iResult = 1;
	}

	CiBrdClose(hBrd);

	return iResult;
}

main()
{
	BFU32 xsize, ysize, PixDepth;
	BFU32 ImageSize;
	MSG Msg;
	BFU32 Num;
	BFU32 Switch, Connector;
	int ch;
	char achDeviceName[256];
	int iResult;

	CiSysBrdEnum(CISYS_TYPE_R64, &Num);

	//	݂{[hiVFGjׂė񋓂
	printf("oꂽ{[h\n");
	for( Switch = 0; Switch < 4; ++Switch ){	//	Switch
		for( Connector = 0; Connector < 4; ++Connector ){	//	Connector
			if (CiSysBoardFindSWConnector(CISYS_TYPE_R64, Switch, Connector, &entry) == CI_OK){
				iResult = GetDeviceName( &entry, achDeviceName );
				printf( "Switch:%d, Connector:%d, Name:%s\n", Switch, Connector, iResult == 0 ? achDeviceName : entry.Name );
			}
		}
	}

	//	{[hAJ{[hw肷B
	printf("\n");
	printf( "XCb`ԍw肵ĂB\n" );
	scanf( "%d", &Switch );
	printf( "RlN^ԍw肵ĂB\n" );
	scanf( "%d", &Connector );
	if (CiSysBoardFindSWConnector(CISYS_TYPE_R64, Switch, Connector, &entry))
	{
		printf("w肳ꂽ{[h܂łB(Switch:%d, Connector:%d)\n", Switch, Connector);
		return -1;
	}


	// {[hI[v
	if (CiBrdOpen(&entry, &hBoard, CiSysInitialize))
	{
		printf("{[hI[vł܂łBI܂B\n");
		return -1;
	}
	
	printf("{[h̃I[v܂B\n");

	/*
	* Display surface I[v
	*/

	// Jt@C̏擾
	CiBrdInquire(hBoard, CiCamInqXSize, &xsize);
	CiBrdInquire(hBoard, CiCamInqYSize0, &ysize);
	CiBrdInquire(hBoard, CiCamInqPixBitDepthDisplay, &PixDepth);
	CiBrdInquire(hBoard, CiCamInqDisplayFrameSize0, &ImageSize);

	hDspSrf = -1;

	// T[tFCX𐶐
	if (!DispSurfCreate((__int32 *)&hDspSrf, xsize, ysize, PixDepth, NULL))
	{
		printf("Display surface ̐Ɏs܂BI܂B\n");
		return -1;
	}

	// rbg}bṽ[obt@擾
	if (!DispSurfGetBitmap(hDspSrf,&pBitmap))
	{
		printf("Display surface Ɋ蓖ĂĂ郁[obt@̎擾Ɏs܂BI܂B\n");
		return -1;
	}

	/*
	* 荞݂̃ZbgAbv
	*/

	if (CiAqSetup(hBoard, pBitmap, ImageSize, 0, CiDMABitmap, BFLutBypass, CiLut8Bit, CiQTabBank0, TRUE, CiQTabModeOneBank, AqEngJ))
	{
		BFErrorShow(hBoard);
		printf("荞݂̃ZbgAbvɎs܂BI܂B\n");
		return -1;
	}
	
	// DMA]p̃VOiݒ
	if (CiSignalCreate(hBoard, CiIntTypeEOD, &EODSignal))
	{
		BFErrorShow(hBoard);
		printf("DMA]̂߂̃VOiɎs܂BI܂B\n");
		return -1;
	}

	// 荞݃Xbh𐶐
	hThread = CreateThread(BFNULL, 0, (LPTHREAD_START_ROUTINE)Thread, (LPVOID) NULL, 0, &dwThreadId);
	
	if (hThread == BFNULL) 
	{
		printf("荞݃Xbh̐Ɏs܂BI܂B\n");
		
		CiBrdClose(hBoard);
		return -1;
	}

	while (!Running)
		Sleep(10);

	/*
	* 荞݊Jn
	*/

	if (CiAqCommand(hBoard, CiConGrab, CiConAsync, CiQTabBank0, AqEngJ))
	{
		BFErrorShow(hBoard);
		printf("荞݊JnɎs܂BI܂B\n");
		return -1;
	}


	printf("Hit 'x' to Exit\n");

	while(Running)
	{
		if(PeekMessage(&Msg,NULL,0,0,PM_REMOVE))
			DispatchMessage(&Msg);

		if (_kbhit())
		{
			ch = _getch();
			switch((char) ch)
			{
			case 'x':
			case 'X':
				
				Running = FALSE;
				
				break;
			}
		}

	}

	/*
	* N[ibv
	*/
	
	// 荞݃Xbhj
	Running = FALSE;

	//	荞݂̒~
	CiAqCommand(hBoard, CiConAbort, CiConAsync, CiQTabBank0, AqEngJ);

	// VOiLZ
	CiSignalCancel(hBoard, &EODSignal);

	Sleep(500);

	// 荞݂I
	CiAqCleanUp(hBoard, AqEngJ);

	// VOi̔j
	CiSignalFree(hBoard, &EODSignal);

	// Display surface N[Y
	if (DispSurfIsOpen(hDspSrf))
		DispSurfClose(hDspSrf);

	// {[hN[Y
	CiBrdClose(hBoard);

	return 0;
}

UINT Thread(LPVOID lpdwParam)
{
	BFRC rv;
	BFU32 count;
	MSG Msg;

	Running = TRUE;
	
	while (Running)
	{
		if(PeekMessage(&Msg,NULL,0,0,PM_REMOVE))
			DispatchMessage(&Msg);

		rv = CiSignalWait(hBoard, &EODSignal, INFINITE, &count);

		if (rv != CI_OK)
		{
			printf("Ending thread\n");
			Running = FALSE;
		}
		else
		{

			if (DispSurfIsOpen(hDspSrf))
			{	
				DispSurfBlit(hDspSrf);
			}

		}
	}

	return 0;
}
